package MoosePerson;
use strict;
use warnings;
use Function::Parameters qw(:strict);
use Moose;

has 'name' => ( is => 'rw', isa => 'Str', default  => 'Shirley' );
has 'sex'  => ( is => 'rw', isa => 'Str', default  => 'f' );
has 'age'  => ( is => 'rw', isa => 'Int', default  => 26 );

method as_string
{
	my $class = ref($self);
	my $name = $self->name;
	my $age = $self->age;
	my $sex = $self->sex;
	return "$class( name=$name, age=$age, sex=$sex )";
}

# stringification
use overload '""' => \&overload_as_string;
fun overload_as_string( $list, $x, $y )    # don't care about last 2 params
{
	return $list->as_string;
}

1;
