package Programmer;
use strict; use warnings;
use Function::Parameters qw(:strict);
use base qw(Person);

method skills( $value = undef ) { return $self->_getset( "SKILLS", $value ); }

method skills_as_string {          # additional method
	my $sk = $self->skills;
	my @str = map { "$_:$sk->{$_}" } sort(keys(%$sk));
	return "{" . join(", ", @str) . "}";
}

method as_string {                 # override method
	my $pers = $self->Person::as_string;
	$pers =~ s/ \)$//;
	my $skills = $self->skills_as_string;
	return "$pers, skills=$skills )";
}

1;
